/*Arduuino program to use a rotary encoder to control the position of a stepper motor.
  A pushbutton connected between 'GND' and pin 'D12' is use to home the stepper motor.
  
  Made by TechBuild: https://www.youtube.com/channel/UCNy7DyfhSD9jsQEgNwETp9g?sub_confirmation=1

  Feel free to modify the code to suit your requirements.

*/
#include <Adafruit_MotorShield.h>

Adafruit_MotorShield AFMS = Adafruit_MotorShield();

Adafruit_StepperMotor *motor = AFMS.getStepper(200, 2);

#define inputA 6
#define inputB 7
#define button 12

int aState;
int aLastState;
long int p = 0;
int s = 0;
int st = 1;
int pulse;

void setup() {
  pinMode (inputA, INPUT);
  pinMode (inputB, INPUT);
  pinMode (button, INPUT_PULLUP);

  AFMS.begin();

  // Reads the initial state of the inputA
  aLastState = digitalRead(inputA);

  motor->setSpeed(150);

}

void loop() {
  aState = digitalRead(inputA); // Reads the "current" state of the inputA
  // If the previous and the current state of the inputA are different, that means a Pulse has occured
  if (aState != aLastState) {

    if (digitalRead(inputB) != aState) {
      s++;
    } else s--;

    //Serial.println(s);



    // If the inputB state is different to the inputA state, that means the encoder is rotating clockwise


  }
  aLastState = aState; // Updates the previous state of the inputA with the current state

  //pulse = pulseIn(inputA, HIGH);



  if (digitalRead(button) == LOW) {

    while (p != 0) {


      if (p > 0) {

        motor->step(p, BACKWARD, DOUBLE);
        p = 0;
      }

      if (p < 0) {
        motor->step(-p, FORWARD, DOUBLE);
        p = 0;
      }

    }
  }
  if (s == 2) {
    motor->step(st, FORWARD, DOUBLE);
    p += st;
    s = 0;
  } else if (s == -2) {
    motor->step(st, BACKWARD, DOUBLE);
    p -= st;
    s = 0;
  }

}
